/*
 * CBMP085.cpp
 *
 *  Created on: 11.10.2013
 *      Author: 
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <exception> // std::exception
#include <stdexcept>

#include "CI2C.h"
#include "CBMP085.h"

/**
 * 
 */
CBMP085::CBMP085 ()
{
	char str[512] = "";
	CI2C ci2c;

	//  
	try
	{
		//  , ..        ))
		ci2c.getI2CDeviceData(str, "oversampling", BMP085_I2C_ID);
	}
	catch (std::exception &e)
	{
		// Barometer BMP-085
		system("/sbin/modprobe bmp085.ko");

		sprintf(str, "echo bmp085 0x%x > /sys/class/i2c-adapter/i2c-1/new_device", BMP085_I2C_ID);
		system(str);
	};
}

/**
 * 
 */
CBMP085::~CBMP085 ()
{
	// TODO Auto-generated destructor stub
}

/**
 *  Barometer BMP-085
 */
bmp085Data CBMP085::get ()
{
	char data[4096] = "";
	bmp085Data bmp085Data;
	CI2C ci2c;

	//  
	try
	{
		//   ( ). -,    (3)
		ci2c.getI2CDeviceData(data, "oversampling", BMP085_I2C_ID);
		bmp085Data.oversampling = atoi(data);

		// 
		ci2c.getI2CDeviceData(data, "pressure0_input", BMP085_I2C_ID);
		bmp085Data.pressure0_input = atoi(data);

		// 
		ci2c.getI2CDeviceData(data, "temp0_input", BMP085_I2C_ID);
		bmp085Data.temp0_input = atoi(data);
	}
	catch (std::exception &e)
	{
		perror(e.what());
	};

	return bmp085Data;
}
