/*
 * CHMC5883.cpp
 *
 *  Created on: 11.10.2013
 *      Author: 
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <exception> // std::exception
#include <stdexcept>

#include "CI2C.h"
#include "CHMC5883.h"

/**
 * 
 */
CHMC5883::CHMC5883 ()
{
	char str[512] = "";
	CI2C ci2c;

	//  
	try
	{
		//  , ..        ))
		ci2c.getI2CDeviceData(str, "conversion", HMC5843_I2C_ID);
	}
	catch (std::exception &e)
	{
		// Compass 3-Axis HMC-5883
		system("/sbin/modprobe hmc5843.ko");

		sprintf(str, "echo hmc5843 0x%x > /sys/class/i2c-adapter/i2c-1/new_device", HMC5843_I2C_ID);
		system(str);

		//  
		sprintf(str, "echo 100 > /sys/bus/i2c/devices/1-00%x/rate", HMC5843_I2C_ID);
		system(str);
	};
}

/**
 * 
 */
CHMC5883::~CHMC5883 ()
{
	// TODO Auto-generated destructor stub
}

/**
 *  Compass 3-Axis HMC-5883
 */
hmc5843Data CHMC5883::get ()
{
	char data[4096] = "";
	hmc5843Data hmc5843Data;
	CI2C ci2c;

	//  
	try
	{
		// -
		ci2c.getI2CDeviceData(hmc5843Data.conversion, "conversion", HMC5843_I2C_ID);

		// -
		ci2c.getI2CDeviceData(data, "counts_per_mgauss", HMC5843_I2C_ID);
		hmc5843Data.counts_per_mgauss = atoi(data);

		// -
		ci2c.getI2CDeviceData(hmc5843Data.mode, "mode", HMC5843_I2C_ID);

		// -
		ci2c.getI2CDeviceData(data, "range", HMC5843_I2C_ID);
		hmc5843Data.range = atoi(data);

		// -
		ci2c.getI2CDeviceData(hmc5843Data.rate, "rate", HMC5843_I2C_ID);

		// -
		ci2c.getI2CDeviceData(hmc5843Data.status, "status", HMC5843_I2C_ID);

		// -
		ci2c.getI2CDeviceData(hmc5843Data.value, "value", HMC5843_I2C_ID);
	}
	catch (std::exception &e)
	{
		perror(e.what());
	};

	return hmc5843Data;
}
