/*
 * CITG3200.cpp
 *
 *  Created on: 11.10.2013
 *      Author: 
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <exception> // std::exception
#include <stdexcept>

#include "CI2C.h"
#include "CITG3200.h"

/**
 * 
 */
CITG3200::CITG3200 ()
{
	char str[512] = "";
	CI2C ci2c;

	//  
	try
	{
		//  , ..        ))
		ci2c.getI2CDeviceData(str, "low_pass", ITG3200_I2C_ID);
	}
	catch (std::exception &e)
	{
		// 3-Axis Gyro ITG-3200 or ITG-3205
		system("/sbin/modprobe itg3200.ko");

		sprintf(str, "echo itg3200 0x%x > /sys/class/i2c-adapter/i2c-1/new_device", ITG3200_I2C_ID);
		system(str);

		//   
		sprintf(str, "echo 0 > /sys/bus/i2c/devices/1-00%x/suspend", ITG3200_I2C_ID);
		system(str);
	};
}

/**
 * 
 */
CITG3200::~CITG3200 ()
{
	// TODO Auto-generated destructor stub
}

/**
 *  3-Axis Gyro ITG-3200 or ITG-3205
 */
itg3200Data CITG3200::get ()
{
	char data[4096] = "";
	itg3200Data itg3200Data;
	CI2C ci2c;

	//  
	try
	{
		//
		ci2c.getI2CDeviceData(data, "low_pass", ITG3200_I2C_ID);
		itg3200Data.low_pass = atoi(data);

		//   
		ci2c.getI2CDeviceData(data, "samplerate", ITG3200_I2C_ID);
		itg3200Data.samplerate = atoi(data);

		//  . = 1 -  , = 0 - 
		ci2c.getI2CDeviceData(data, "suspend", ITG3200_I2C_ID);
		itg3200Data.suspend = atoi(data);

		//   
		ci2c.getI2CDeviceData(itg3200Data.values, "values", ITG3200_I2C_ID);
	}
	catch (std::exception &e)
	{
		perror(e.what());
	};

	return itg3200Data;
}

