//============================================================================
// Name        : GafkV2RServer.cpp
// Author      :   
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++
//============================================================================

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>
#include <iostream>
#include <exception> // std::exception

//    BMP-085
#include "CBMP085.h"

//    HMC-5883
#include "CHMC5883.h"

//    ITG-3200/ITG-3205
#include "CITG3200.h"

/**
 *  
 */
int main (void)
{
	printf(" ...\n");

	// Accelerometer 3-Axis ADXL-345
/*
	system("/sbin/modprobe adxl34x.ko");
	system("echo adxl34x 0x53 > /sys/class/i2c-adapter/i2c-1/new_device");
*/

	//  Barometer BMP-085
	CBMP085 bmp085;

	//  Compass 3-Axis HMC-5883
	CHMC5883 hmc5843;

	//  3-Axis Gyro ITG-3200 or ITG-3205
	CITG3200 itg3200;
/*
	//  
	while (1)
	{
		printf("   2");
	}
*/

	//  Barometer BMP-085
	bmp085Data bmp085Data = bmp085.get();
	printf("Data device - oversampling: %d, pressure0_input: %d, temp0_input: %d\n", bmp085Data.oversampling, bmp085Data.pressure0_input, bmp085Data.temp0_input);

	//  Compass 3-Axis HMC-5883
	hmc5843Data hmc5843Data = hmc5843.get();
	printf(
		"Data device - conversion: %s, counts_per_mgauss: %d, mode: %s, range: %d, rate: %s, status: %s, value: %s\n",
		hmc5843Data.conversion,
		hmc5843Data.counts_per_mgauss,
		hmc5843Data.mode,
		hmc5843Data.range,
		hmc5843Data.rate,
		hmc5843Data.status,
		hmc5843Data.value);

	//  Compass 3-Axis HMC-5883
	itg3200Data itg3200Data = itg3200.get();
	printf("Data device - low_pass: %d, samplerate: %d, suspend: %d, values: %s\n", itg3200Data.low_pass, itg3200Data.samplerate, itg3200Data.suspend, itg3200Data.values);

	return 0;
}

/*
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <string.h>
#include <time.h>
void MOSINT();

#define rt1 write(0,"ggg1gg\n",7);
#define rt2 write(0,"ggg2gg\n",7);
#define rt3 write(0,"ggg3gg\n",7);
#define rt4 write(0,"ggg4gg\n",7);
#define rt5 write(0,"ggg5gg\n",7);
#define rt write(0,"\n",1);

int fd;
char buf[1024];
int bytes_read;
int sock;
struct sockaddr_in addr;

int main()
{
sock=0;
fd=0;

//Set PWM on pins
system("echo 'set con44 pwm1' > /dev/v2r_pins");
system("echo 'set con43 pwm0' > /dev/v2r_pins");

//Restart Label
startserver:


// USART0 open port
fd = open("/dev/ttyS0",O_RDWR | O_NOCTTY | O_NDELAY);
if (fd == -1) {fprintf(stderr,"open_port: Unable to open ports ");goto ex;}




//Socket create
sock = socket(AF_INET, SOCK_DGRAM, 0);
if(sock < 0) {perror("socket");goto ex;}

//Socket configuration
addr.sin_family = AF_INET;
addr.sin_port = htons(10600);
addr.sin_addr.s_addr = htonl(INADDR_ANY);;


//Try to bind port for Socket
if(bind(sock, (struct sockaddr *)&addr, sizeof(addr)) < 0)
{goto ex;}

// Main cycle
while(1)
{
bytes_read = recv(sock, buf, 1024, 0);
if(bytes_read <= 0) {break;}
MOSINT();
write(0, buf, bytes_read);
write(fd, buf, bytes_read);
}

// Error handler
ex:
if (fd!=0) close(fd);
if (sock!=0) close(sock);
sleep(1);
goto startserver;

return 0;
}

int i2=0,flag=0;
void interpreter();
char buffer[100],kekeke[100];
unsigned int n_INT=0;
char inChar;

void MOSINT()
{st:

for(;i2<bytes_read;i2++)
{
inChar=buf[i2];
if (inChar=='|') {goto startint;}
if (n_INT<100-1) {buffer[n_INT]=inChar; n_INT++;}
}

return;

startint:

buffer[n_INT] = 0x00;
interpreter();
n_INT=0;
if (i2+1<bytes_read) {i2++;goto st;}
i2=0;
}


#define T 4
#include <stdlib.h>
#include <limits.h>
unsigned long m;
unsigned long lastm=0,lastm2=0;
char strsys[100]="";char strtemp[100]="";
unsigned long duty;
void interpreter(void)
{char* c;
strsys[0]=0;
strsys[1]=0;
unsigned int i=0;
for (;(i<strlen(buffer)) && (buffer[i]==' ');i++);
for (;(i<strlen(buffer)) && (buffer[i]!=' ');i++);
c=(buffer+i);
c[0]=0x00;
c=c+1;


if(!strcmp(buffer,"serv1")) {
strcat(strsys,"echo 'set pwm1 duty:");
sprintf(strtemp,"%d",atoi(c)*(57000-13000)/180+13000);
strcat(strsys,strtemp);

strcat(strsys," period:700000' > /dev/v2r_pins");
if (clock()-lastm>T)
{   lastm=clock();
system(strsys);
}
}
if(!strcmp(buffer,"serv2")) {
strcat(strsys,"echo 'set pwm0 duty:");
sprintf(strtemp,"%d",atoi(c)*(57000-13000)/180+13000);
strcat(strsys,strtemp);

strcat(strsys," period:700000' > /dev/v2r_pins");
if (clock()-lastm2>T)
{   lastm2=clock();
system(strsys);
}}

}

*/
